/*     DO WHAT THE FUCK YOU WANT TO PUBLIC LICENSE
                    Version 2, December 2004

 Copyright (C) 2009 Adinpsz contributors
  7 chemin Villebois 38100 Grenoble
 Everyone is permitted to copy and distribute verbatim or modified
 copies of this license document, and changing it is allowed as long
 as the name is changed.

            DO WHAT THE FUCK YOU WANT TO PUBLIC LICENSE
   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION

  0. You just DO WHAT THE FUCK YOU WANT TO. */
/* This program is free software. It comes without any warranty, to
 * the extent permitted by applicable law. You can redistribute it
 * and/or modify it under the terms of the Do What The Fuck You Want
 * To Public License, Version 2, as published by Sam Hocevar. See
 * http://sam.zoy.org/wtfpl/COPYING for more details. */ 
module audio.delayline;

import audio.types;
import audio.audiobuffer;
import std.stdio;


class DelayLine : AudioBuffer
{
	private
	{
		const int TOO_MUCH_DELAY = 1048576;
		
		int writeIndex; // where to write
		int mask;
		
		int requiredLength(float samples) // return the first n with 2^n >= samples
		{
			int i = 1;
			while (i < samples + 4) 
			{
				i <<= 1;
			}
			return i;
		}
	}
	
	public
	{
		this(float maximum_delay) // in samples
		{
			maximum_delay += 4; // for sampling
						 
			final auto computedLength = requiredLength(maximum_delay);
			assert(computedLength <= TOO_MUCH_DELAY);
			super(computedLength);
			mask = computedLength - 1;
			
		}
		
		void feed(float x)
		{			
			data[writeIndex = (writeIndex + 1) & mask] = x;
		}
		
		float read(float x) // read x samples before writeIndex
		{	
			float res = sample(writeIndex - x, SamplingMode.LINEAR, BorderMode.LOOP);
			return res;
		}
	}
}

