/*     DO WHAT THE FUCK YOU WANT TO PUBLIC LICENSE
                    Version 2, December 2004

 Copyright (C) 2009 Adinpsz contributors
  7 chemin Villebois 38100 Grenoble
 Everyone is permitted to copy and distribute verbatim or modified
 copies of this license document, and changing it is allowed as long
 as the name is changed.

            DO WHAT THE FUCK YOU WANT TO PUBLIC LICENSE
   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION

  0. You just DO WHAT THE FUCK YOU WANT TO. */
/* This program is free software. It comes without any warranty, to
 * the extent permitted by applicable law. You can redistribute it
 * and/or modify it under the terms of the Do What The Fuck You Want
 * To Public License, Version 2, as published by Sam Hocevar. See
 * http://sam.zoy.org/wtfpl/COPYING for more details. */ 
module audio.modules.stereomixer;

private import audio.allwhatmodulesneed;

class StereoMixer : AudioModule
{		
	protected
	{	
		override void doProcess()
		{
			auto outBuffers = cast(StereoAnalogData)(output(0).data());
			
			
			AudioBuffer bL = outBuffers.left;
			AudioBuffer bR = outBuffers.right;
			
			bL.clear();
			bR.clear();
			for (int n = 0; n < trackNumber; n++)
			{
				final auto inBuffers = cast(StereoAnalogData)input(getChannel(n)).data;
				final auto volumeData = cast(FloatData)input(getChannelVolume(n)).data;
				
				if ((volumeData is null) || (inBuffers is null)) continue;
				
				final float volume = volumeData.value;
				
				bL.accumulate(inBuffers.left, volume);
				bR.accumulate(inBuffers.right, volume);				
			}						
		}		
	}
	
	private
	{
		
		int trackNumber;
		
		static int getChannel(int i)
		{
			return 2 * i;
		}
		
		static int getChannelVolume(int i)
		{
			return 2 * i + 1;
		}
		
	}
	
	public
	{
		this(int trackNumber)
		{
			super("STEREOMIXER");
			addOutput("OUT", AudioDataType.STEREO_ANALOG); 
			for (int i = 0; i < trackNumber; i++)
			{
				addInput(format("CH%d", i), AudioDataType.STEREO_ANALOG);
				addInput(format("GAIN%d", i), AudioDataType.FLOAT);				
			}
			this.trackNumber = trackNumber;
		}	
		
		
	}	
	
}


