/*     DO WHAT THE FUCK YOU WANT TO PUBLIC LICENSE
                    Version 2, December 2004

 Copyright (C) 2009 Adinpsz contributors
  7 chemin Villebois 38100 Grenoble
 Everyone is permitted to copy and distribute verbatim or modified
 copies of this license document, and changing it is allowed as long
 as the name is changed.

            DO WHAT THE FUCK YOU WANT TO PUBLIC LICENSE
   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION

  0. You just DO WHAT THE FUCK YOU WANT TO. */
/* This program is free software. It comes without any warranty, to
 * the extent permitted by applicable law. You can redistribute it
 * and/or modify it under the terms of the Do What The Fuck You Want
 * To Public License, Version 2, as published by Sam Hocevar. See
 * http://sam.zoy.org/wtfpl/COPYING for more details. */ 
module audio.slope;

import audio.types;
import audio.constants;
import util.math;

// not usable !

struct Slope // exponential slope
{
	private
	{
		float time;
		float current;
		float slope;
		float start, stop;		
		
		float d;
		float offset;
		float one_over_duration;
	}
	
	public
	{
		void init(float start, float stop, float duration, float slope)
		{
			this.time = 0;
			this.start = this.current = start;
			this.stop = stop;
			setSlope(slope);
			setDuration(duration);
		}
		
		
		void setSlope(float slope)
		{
			this.slope = slope;	
			this.d = 2 * sinh(slope);
			this.offset = -exp(-slope);
		}
		
		void setDuration(float duration)
		{			
			this.one_over_duration = 1.f / duration;
		}
		
		float next(float timeIncrement, out bool finished)
		{
			if (abs(d) < 1e-7)
			{
				current = lerp(start, stop, time);
			} else
			{
				final float a = (expf(2.f * (time - 0.5f) * slope) + offset) / d;
				current = lerp(start, stop, a);
			} 
			
			time += timeIncrement * one_over_duration;
			finished = (time > 1.f);			
			
			return current;
		}		
	}
}




