/*     DO WHAT THE FUCK YOU WANT TO PUBLIC LICENSE
                    Version 2, December 2004

 Copyright (C) 2009 Adinpsz contributors
  7 chemin Villebois 38100 Grenoble
 Everyone is permitted to copy and distribute verbatim or modified
 copies of this license document, and changing it is allowed as long
 as the name is changed.

            DO WHAT THE FUCK YOU WANT TO PUBLIC LICENSE
   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION

  0. You just DO WHAT THE FUCK YOU WANT TO. */
/* This program is free software. It comes without any warranty, to
 * the extent permitted by applicable law. You can redistribute it
 * and/or modify it under the terms of the Do What The Fuck You Want
 * To Public License, Version 2, as published by Sam Hocevar. See
 * http://sam.zoy.org/wtfpl/COPYING for more details. */ 
module audio.utils;

private import audio.types;
private import audio.constants;
private import util.math;


float audioClip(float x)
{
	static const float LIM_INF = cast(float) -1;
	static const float LIM_SUP = cast(float) +1;
	if (x < LIM_INF) 
	{
		return LIM_INF;
	} else if (x > LIM_SUP)
	{
		return LIM_SUP;	
	} else 
	{
		return x;
	}
}


// time conversion
float bpm_to_freq(float bpm) {	return bpm / 60.f; }
float freq_to_bpm(float frequency) { return 60.f / frequency; }

float bpm_to_sec(float bpm) { 	return 60.f / bpm; }
float sec_to_bpm(float bpm) { 	return bpm / 60.f; }

float freq_to_sec(float frequency) { return 1.f / frequency; }
float sec_to_freq(float seconds) { return 1.f / seconds; }

float sec_to_samples(float seconds) { return seconds * SAMPLE_RATE_F; }
float samples_to_sec(float samples) { return samples * SAMPLE_RATE_INV_F; }

// amplitude conversion

float db_to_float(float db)
{
	return pow(10.f, 0.05f * db);	
}

float float_to_db(float x)
{
	return 20.f * log10(x);
}