/*     DO WHAT THE FUCK YOU WANT TO PUBLIC LICENSE
                    Version 2, December 2004

 Copyright (C) 2009 Adinpsz contributors
  7 chemin Villebois 38100 Grenoble
 Everyone is permitted to copy and distribute verbatim or modified
 copies of this license document, and changing it is allowed as long
 as the name is changed.

            DO WHAT THE FUCK YOU WANT TO PUBLIC LICENSE
   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION

  0. You just DO WHAT THE FUCK YOU WANT TO. */
/* This program is free software. It comes without any warranty, to
 * the extent permitted by applicable law. You can redistribute it
 * and/or modify it under the terms of the Do What The Fuck You Want
 * To Public License, Version 2, as published by Sam Hocevar. See
 * http://sam.zoy.org/wtfpl/COPYING for more details. */ 
module demo.logofinaleffect;


import demo.effect;
import demo.demo;
import util.all;
import util.geometry.all;
import gl.all;


final class LogoFinalEffect : Effect
{
	private 
	{
		ShaderProgram m_shader;
		Texture2D m_logo;
	}
	
	public
	{
		this(vec2d interval, int priority)
		{
			super("Logofinal", interval, priority);			
		}					
		
		override bool isPaperEffect() { return false; }
			
		override void onLoad() // load resources
		{
			m_shader = new ShaderProgram("data/shaders/logofinal_vertex.glsl", "data/shaders/logofinal_pixel.glsl");
			m_logo = demo.loadTexture2D("data/tex/logofinal.png", Texture.Filter.LINEAR_MIPMAP_LINEAR, Texture.Filter.LINEAR, Texture.Wrap.CLAMP_TO_EDGE, true);
			
			m_shader.setSampler("tex", m_logo, 0);
		}
		
		override void onDraw() // draw effect
		{
			// transmit to graphics
			demo.mainFBO.use();
			
			m_shader.use();
				
			GL.projectionMatrix = mat4f.scale( vec3f(1.f / demo.ratio, 1.f, 1.f));
			GL.modelviewMatrix = mat4f.IDENTITY;
			
			GL.disable( GL_DEPTH_TEST, GL_ALPHA_TEST, GL_LINE_SMOOTH, GL_POLYGON_SMOOTH, GL_POINT_SMOOTH );
			
			GL.enable(GL_BLEND);
		    GL.setBlend(GL.BlendMode.ADD, GL.BlendFactor.SRC_ALPHA, GL.BlendFactor.ONE_MINUS_SRC_ALPHA, 
		                GL.BlendMode.MAX, GL.BlendFactor.ONE, GL.BlendFactor.ONE);
			
			float ratio = demo.ratio;
			auto U = 1.f * ratio * 3.f / 4.f;
			glColor4f(1.5,1.5,1.5,smoothStep(0.f,4.f, localTime));
			
			glBegin(GL_QUADS);
				glTexCoord2f(0,1); glVertex2f(-ratio ,-U);	
				glTexCoord2f(1,1); glVertex2f(+ratio ,-U);
				glTexCoord2f(1,0); glVertex2f(+ratio ,+U);
				glTexCoord2f(0,0); glVertex2f(-ratio ,+U);
			glEnd();	
		}
		
		void onMove(double dt) // move effect
		{
				
		}
	}	
}