/*     DO WHAT THE FUCK YOU WANT TO PUBLIC LICENSE
                    Version 2, December 2004

 Copyright (C) 2009 Adinpsz contributors
  7 chemin Villebois 38100 Grenoble
 Everyone is permitted to copy and distribute verbatim or modified
 copies of this license document, and changing it is allowed as long
 as the name is changed.

            DO WHAT THE FUCK YOU WANT TO PUBLIC LICENSE
   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION

  0. You just DO WHAT THE FUCK YOU WANT TO. */
/* This program is free software. It comes without any warranty, to
 * the extent permitted by applicable law. You can redistribute it
 * and/or modify it under the terms of the Do What The Fuck You Want
 * To Public License, Version 2, as published by Sam Hocevar. See
 * http://sam.zoy.org/wtfpl/COPYING for more details. */ 
module demo.scene10;

import demo.effect;
import util.all;
import util.geometry.all;
import gl.all;
import demo.tunnelpath;


final class Scene10 : Effect
{
	public
	{
		auto const N_CIRCLES = 12;			
	}
	
	private 
	{
		ShaderProgram m_shader;
		Texture2D m_tex;
		int m_next = 0;
		
		vec4f[N_CIRCLES] pos; // represent (X, Y, RADIUS, INTENSITY), if radius < 0 then no spiral
		
		float lastadd = -10.f;
		
		void drawCircle(vec4f p)
		{
			float radius = p.z * 2.0f;
			if (radius < 0.f) return;
			float alpha = p.w * 0.6f;
			float x = p.x;	
			float y = p.y;	
			float perimetre = 2.f * PI_F * radius;
			int subdiv = round(perimetre / 0.02f);
			if (subdiv < 20) subdiv = 20;
			float D = 0.03f + 0.03f * demo.musicVolume();
			
			glMatrixMode(GL_MODELVIEW);
			glPushMatrix();
			glTranslatef(x, y, 0);
			
			glBegin(GL_QUAD_STRIP);
			for (int i = 0; i <= subdiv; ++i)
			{
				float sin, cos;
				sincos( 2.f * PI_F * i / cast(float)subdiv, sin, cos);
				glColor4f(0.f,0.f,0.f,alpha); glVertex2f(sin * radius, cos * radius);
				glColor4f(0.f,0.f,0.f,0.f); glVertex2f(sin * (radius + D), cos * (radius + D));
			}
			glEnd();
			
			auto D2 = max(0.f, radius - D);
			
			glBegin(GL_QUAD_STRIP);
			for (int i = 0; i <= subdiv; ++i)
			{
				float sin, cos;
				sincos( 2.f * PI_F * i / cast(float)subdiv, sin, cos);
				glColor4f(0.f,0.f,0.f,alpha); glVertex2f(sin * radius, cos * radius);
				glColor4f(0.f,0.f,0.f,alpha * 0.3f); glVertex2f(sin * D2, cos * D2);
			}
			glEnd();
			
			if (D2 > 0.f)
			{
				auto D3 = max(0.f, radius - D * 3.f);
				glBegin(GL_QUAD_STRIP);
				for (int i = 0; i <= subdiv; ++i)
				{
					float sin, cos;
					sincos( 2.f * PI_F * i / cast(float)subdiv, sin, cos);
					glColor4f(0.f,0.f,0.f,alpha * 0.3f); glVertex2f(sin * D2, cos * D2);
					glColor4f(0.f,0.f,0.f,alpha * 0.1f); glVertex2f(sin * D3, cos * D3);
				}
				glEnd();
				
				
				if (D3 > 0.f)
				{
					auto D4 = max(0.f, radius - D * 8.f);
					glBegin(GL_QUAD_STRIP);
					for (int i = 0; i <= subdiv; ++i)
					{
						float sin, cos;
						sincos( 2.f * PI_F * i / cast(float)subdiv, sin, cos);
						glColor4f(0.f,0.f,0.f,alpha * 0.1f); glVertex2f(sin * D3, cos * D3);
						glColor4f(0.f,0.f,0.f,alpha * 0.0f); glVertex2f(sin * D4, cos * D4);
					}
					glEnd();
					
				}
					
			}
			glPopMatrix();			
			
		}
	}
	
	public
	{
		
		this(vec2d interval, int priority)
		{
			super("Scene10", interval, priority);
		}		
		
		override void onLoad() // load resources
		{	
			//m_shader = new ShaderProgram("data/shaders/scene10_vertex.glsl", "data/shaders/scene10_pixel.glsl");
			m_shader = new ShaderProgram("data/shaders/put_vertex.glsl", "data/shaders/put_pixel.glsl");
			
			for (int i = 0; i < pos.length; ++i)
			{
				pos[i] = vec4f(0,0,-10000.f, 0.f);	
			}
		}	
		
		int nGoutte = 0;
		
		
		void goutte(float x, float y)
		{
			int next = m_next;
			m_next = (m_next + 1) % N_CIRCLES;
			pos[next] = vec4f(x, y, 0.f, 1.0f + 0.1f * randFloat());
		}	
		
		override bool isPaperEffect() { return true; }
			
		override void onDraw() // draw effect
		{
			// passe 1 : le decor
			demo.mainFBO.use();			
		    m_shader.use();
		    
	//	    m_shader.set4fv("pos", pos);
		//    m_shader.set1f("localTime", localTime);
	//		m_shader.set1f("musicVolume", demo.musicVolume);
		    
		    GL.disable( [ GL_DEPTH_TEST, GL_ALPHA_TEST, GL_LINE_SMOOTH, GL_POLYGON_SMOOTH, GL_POINT_SMOOTH ] );     
		    GL.enable(GL_BLEND);
		    GL.setBlend(GL.BlendMode.ADD, GL.BlendFactor.SRC_ALPHA, GL.BlendFactor.ONE_MINUS_SRC_ALPHA, 
		                GL.BlendMode.MAX, GL.BlendFactor.ONE, GL.BlendFactor.ONE);
		    
		    auto ratio = demo.ratio;
		    
		    GL.projectionMatrix = mat4f.scale(vec3f(1.f / demo.ratio, 1.f, 1.f)); // to span all the screen
			GL.modelviewMatrix = mat4f.IDENTITY;		
			
			glClearColor(1.f,1.f,1.f,1.f);
			glClear(GL_COLOR_BUFFER_BIT);	
			/*
			glBegin(GL_QUADS);
				glTexCoord2f(-ratio,-1); glVertex2f(-ratio,-1);	
				glTexCoord2f(ratio,-1); glVertex2f(+ratio,-1);
				glTexCoord2f(ratio,+1); glVertex2f(+ratio,+1);
				glTexCoord2f(-ratio,+1); glVertex2f(-ratio,+1);				
			glEnd();
			*/
			
			for (int i = 0; i < pos.length; ++i)
			{
				drawCircle(pos[i]);				
			}
			
			
			
			auto width = 1.5f + 0.7f * demo.musicVolume;
			//vec4f c1 = vec4f(1.0f,0.8f,0.7f, 1.f);
			vec4f c1 = vec4f(1.0f,1.0f,0.95f, 1.f);
			//vec4f c2 = vec4f(0.8f,1.0f,0.7f, 1.f);
			vec4f c2 = vec4f(1.0f,1.0f,0.95f, 1.f);
			
			auto beat = localBeat();
			
			if ((8 <= beat) && (beat < 12)) demo.bitmapFont.drawString(0, 0.f, width, c1, c2, "Hello numerica !");
			if ((12 <= beat) && (beat < 16)) demo.bitmapFont.drawString(0, -0.33f, width, c1, c2, "We are adinpsz");
			if ((16 <= beat) && (beat < 20)) demo.bitmapFont.drawString(0, 0.33f, width, c1, c2, "This is our first demo");
			
			if ((20 <= beat) && (beat < 24)) 
			{
				demo.bitmapFont.drawString(0, 0.33, width, c2, c1, "Please moderate");
				demo.bitmapFont.drawString(0,-0.33, width, c2, c1, "your laughter");	
			}
		}
		
		
		override void onMove(double dt) // move effect
		{
			for (int i = 0; i < pos.length; ++i)
			{
				if (pos[i].z >= 0.f)
				{
					pos[i].z = pos[i].z + dt * 0.5f;	
					if (localBeat >= 16) pos[i].z = pos[i].z + dt * 0.08f;	
					
					pos[i].w = pos[i].w - dt * 0.3f;
					if (pos[i].w < 0.f)
					{
						pos[i].z = -10000.f;
					}
				}
			}
			
			if (demo.musicVolume > 0.8f)
			{
				auto now = localTime;
				if ((now - lastadd) > 0.400) // at least 500 ms between two drops
				{
					float x, y;
					int beat = localBeat;
					if ((0 <= beat) && (beat < 8)) 
					{
						x = y = 0.f;
						goutte(x, y);	
					} else if ((8 <= beat) && (beat < 24)) 
					{
						float d = (nGoutte - 8) * 0.05f;
						x = cos(0.5f * (nGoutte-8) * PI_F) * d;
						y = sin(0.5f * (nGoutte-8) * PI_F) * d;
						goutte(x, y);
						goutte(-x, -y);	
					} else
					{
						x = 0.f;	
						y = 0.89f + 0.2f * smoothStep(timePerBeat * 28.f, timePerBeat * 30.f, localTime);;
						goutte(x, y);						
					}									
					nGoutte++;
					lastadd = now;
				}
			}
		}
	}
}


