/*     DO WHAT THE FUCK YOU WANT TO PUBLIC LICENSE
                    Version 2, December 2004

 Copyright (C) 2009 Adinpsz contributors
  7 chemin Villebois 38100 Grenoble
 Everyone is permitted to copy and distribute verbatim or modified
 copies of this license document, and changing it is allowed as long
 as the name is changed.

            DO WHAT THE FUCK YOU WANT TO PUBLIC LICENSE
   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION

  0. You just DO WHAT THE FUCK YOU WANT TO. */
/* This program is free software. It comes without any warranty, to
 * the extent permitted by applicable law. You can redistribute it
 * and/or modify it under the terms of the Do What The Fuck You Want
 * To Public License, Version 2, as published by Sam Hocevar. See
 * http://sam.zoy.org/wtfpl/COPYING for more details. */ 
module util.random;


private 
{	
	uint randSeed = 0;	
}

public
{
	// initialize the random seed
	final void srand(uint seed)
	{
		randSeed = seed;	
	}	
	
	// get a random integer
	final uint randUint() 
	{
		return (randSeed = (randSeed * 1664525) + 1013904223);
	}
	
	// get a random integer
	final int randInt() 
	{
		return (randSeed = (randSeed * 1664525) + 1013904223);
	}
	
	// get a random integer in [0..range-1]
	final int randRange(int range)
	{
		return cast(int) (randDouble() * range);
	}
	
	// get a random integer in the range [min, max_p_1 - 1]
	final int randRange(int min, int max_p_1)
	{
		return min + randRange(max_p_1 - min);
	}
	
	// returns a float in [0; 1 [
	final float randFloat()
	{		
		return cast(double)(randUint()) / cast(double)(uint.max + 1.0) ;
	}
	
	// returns a double in [0; 1 [
	final double randDouble()
	{		
		return cast(double)(randUint()) / cast(double)(uint.max + 1.0) ;
	}
	
	// approximate a Gaussian noise
	final float randGaussf() 
	{		
		return (randFloat() + randFloat() + randFloat() - 1.5f) / 1.5f;
	}
}
